--- /dev/null
+++ b/zipl/boot/sclp.c
@@ -0,0 +1,361 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Functions for console input and output.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "error.h"
+#include "sclp.h"
+#include "s390.h"
+
+/* Perform service call. Return 0 on success, non-zero otherwise. */
+static int sclp_service_call(unsigned int command, void *sccb)
+{
+	int cc;
+
+	asm volatile(
+		"       .insn   rre,0xb2200000,%1,%2\n"  /* servc %1,%2 */
+		"       ipm     %0\n"
+		"       srl     %0,28"
+		: "=&d" (cc)
+		: "d" (command), "a" (sccb)
+		: "cc", "memory");
+	if (cc == 3)
+		return 3;
+	if (cc == 2)
+		return 2;
+	return 0;
+}
+
+static inline int wait(void)
+{
+	do {
+		load_wait_psw(0x0102000180000000ULL, &S390_lowcore.external_new_psw);
+		if (S390_lowcore.ext_int_code == 0x1004)
+			return ETIMEOUT;
+	} while (S390_lowcore.ext_int_code != 0x2401);
+
+	return 0;
+}
+
+int sclp_wait_for_int(unsigned long long timeout)
+{
+	unsigned long old_ctl, ctl;
+	uint64_t time;
+	int rc;
+
+	if (timeout) {
+		timeout <<= 32;
+		time = get_tod_clock();
+		time += timeout;
+		set_clock_comparator(time);
+	}
+
+	/* get control register 0 */
+	__ctl_store(old_ctl, 0, 0);
+
+	ctl = old_ctl;
+	/* set new mask */
+	ctl |= CTL_SERVICE_SIGNAL;
+	if (timeout)
+		ctl |= CTL_CLOCK_COMPARATOR;
+	else
+		ctl &= ~CTL_CLOCK_COMPARATOR;
+	/* write control register 0 */
+	__ctl_load(ctl, 0, 0);
+
+	rc = wait();
+
+	/* restore old control register 0 */
+	__ctl_load(old_ctl, 0, 0);
+
+	return rc;
+}
+
+int start_sclp(unsigned int cmd, void *sccb)
+{
+	int rc;
+
+	while (1) {
+		rc = sclp_service_call(cmd, sccb);
+		if (rc == 3)
+			return 1;
+
+		if (rc == 2)
+			sclp_wait_for_int(0);
+		else
+			break;
+	}
+	sclp_wait_for_int(0);
+	return 0;
+}
+
+static int mask_is_set(sccb_mask_t mask_to_set, sccb_mask_t mask_set)
+{
+	return (mask_to_set & mask_set) == mask_to_set;
+}
+
+int sclp_setup(int initialise)
+{
+	struct init_sccb *sccb;
+	unsigned int cmd;
+	int rc;
+
+	sccb = (void *)get_zeroed_page();
+	sccb->header.length = sizeof(struct init_sccb);
+	sccb->mask_length = 4;
+
+	switch (initialise) {
+	case SCLP_INIT:
+		sccb->receive_mask = 0x80000000;
+		sccb->send_mask = 0x40000000;
+		break;
+	case SCLP_DISABLE:
+		sccb->receive_mask = 0x0;
+		sccb->send_mask = 0x0;
+		break;
+	case SCLP_HSA_INIT:
+		sccb->receive_mask = 0x0;
+		sccb->send_mask = 0x40000010;
+		break;
+	case SCLP_HSA_INIT_ASYNC:
+		sccb->receive_mask = 0x00000010;
+		sccb->send_mask = 0x40000010;
+		break;
+	}
+
+	cmd = SCLP_CMD_WRITE_MASK;
+	rc = start_sclp(cmd, sccb);
+	if (rc || sccb->header.response_code != 0x20) {
+		rc = 1;
+		goto out_free_page;
+	}
+
+	if (!mask_is_set(sccb->send_mask, sccb->sclp_send_mask) ||
+	    !mask_is_set(sccb->receive_mask, sccb->sclp_receive_mask)) {
+		rc = 1;
+		goto out_free_page;
+	}
+	rc = 0;
+out_free_page:
+	free_page((unsigned long) sccb);
+	return rc;
+}
+
+int sclp_print(char *buffer)
+{
+	struct write_sccb *sccb;
+	struct mto *mto;
+	char *data;
+	unsigned int cmd;
+	int rc, i = 0;
+
+	sccb = (void *)get_zeroed_page();
+	mto = (void *)((char *)sccb) + sizeof(struct write_sccb);
+	data = (char *)mto + sizeof(struct mto);
+	sccb->header.length = sizeof(struct write_sccb);
+	sccb->msg_buf.header.length =  sizeof(struct msg_buf);
+	sccb->msg_buf.header.type = 0x02;
+	sccb->msg_buf.mdb.header.length = sizeof(struct mdb);
+	sccb->msg_buf.mdb.header.type = 1;
+	sccb->msg_buf.mdb.header.tag = EBC_MDB;
+	sccb->msg_buf.mdb.header.revision_code = 1;
+	sccb->msg_buf.mdb.go.length = sizeof(struct go);
+	sccb->msg_buf.mdb.go.type = 1;
+
+	while (buffer[i] != 0) {
+		memset(mto, 0, sizeof(struct mto));
+		mto->length = sizeof(struct mto);
+		mto->type = 4;
+		mto->line_type_flags = 0x1000;
+
+		/*
+		 * while not end of string and not end of line
+		 * copy characterwise
+		 */
+		while (buffer[i] != 0 && buffer[i] != 0x15) {
+			*data = buffer[i];
+			mto->length++;
+			data++;
+			i++;
+		}
+
+		/* update lengths */
+		sccb->msg_buf.mdb.header.length += mto->length;
+		sccb->msg_buf.header.length +=  mto->length;
+		sccb->header.length +=  mto->length;
+
+		/* if another line is remaining build a new mto */
+		if (buffer[i] != 0) {
+			mto = (struct mto *)data;
+			data = (char *)mto + sizeof(struct mto);
+			i++;
+		}
+	}
+
+	/* SCLP command for write data */
+	cmd = SCLP_CMD_WRITE_DATA;
+	rc = start_sclp(cmd, sccb);
+	if (rc || sccb->header.response_code != 0x20) {
+		rc = 1;
+		goto out_free_page;
+	}
+	rc = 0;
+out_free_page:
+	free_page((unsigned long) sccb);
+	return rc;
+}
+
+int sclp_read_info(struct read_info_sccb *sccb)
+{
+	unsigned int cmd;
+	int rc;
+
+	sccb->header.length = sizeof(struct read_info_sccb);
+	cmd = SCLP_CMD_READ_INFO;
+
+	rc = start_sclp(cmd, sccb);
+
+	if (rc)
+		return 1;
+
+	if (sccb->header.response_code != 0x10) {
+		cmd = SCLP_CMD_READ_INFO2;
+		rc = start_sclp(cmd, sccb);
+	}
+
+	if (rc || sccb->header.response_code != 0x10)
+		return 2;
+
+	return 0;
+}
+
+int sclp_param(char *loadparm)
+{
+	struct read_info_sccb *sccb;
+	int rc;
+
+	sccb = (void *)get_zeroed_page();
+	rc = sclp_read_info(sccb);
+
+	if (rc == 0)
+		memcpy(loadparm, sccb->loadparm, 8);
+	free_page((unsigned long) sccb);
+	return rc;
+}
+
+static struct gds_vector *sclp_find_gds_vector(void *start, void *end, uint16_t id)
+{
+	struct gds_vector *v;
+
+	for (v = start; (void *)v < end; v = (void *)v + v->length)
+		if (v->gds_id == id)
+			return v;
+	return NULL;
+}
+
+static struct gds_subvector *sclp_eval_selfdeftextmsg(struct gds_subvector *sv)
+{
+	void *end;
+
+	end = (void *)sv + sv->length;
+	for (sv = sv + 1; (void *)sv < end; sv = (void *)sv + sv->length)
+		if (sv->key == 0x30)
+			return sv;
+
+	return NULL;
+}
+
+static struct gds_subvector *sclp_eval_textcmd(struct gds_vector *v)
+{
+	struct gds_subvector *sv;
+	void *end;
+
+	end = (void *)v + v->length;
+	for (sv = (struct gds_subvector *)(v + 1); (void *)sv < end;
+	     sv = (void *)sv + sv->length)
+		if (sv->key == GDS_KEY_SELFDEFTEXTMSG)
+			return sclp_eval_selfdeftextmsg(sv);
+
+	return NULL;
+}
+
+static struct gds_subvector *sclp_eval_cpmsu(struct gds_vector *v)
+{
+	void *end;
+
+	end = (void *)v + v->length;
+	for (v = v + 1; (void *)v < end; v = (void *)v + v->length)
+		if (v->gds_id == GDS_ID_TEXTCMD)
+			return sclp_eval_textcmd(v);
+
+	return NULL;
+}
+
+static struct gds_subvector *sclp_eval_mdsmu(struct gds_vector *v)
+{
+	v = sclp_find_gds_vector(v + 1, (void *)v + v->length, GDS_ID_CPMSU);
+	if (v)
+		return sclp_eval_cpmsu(v);
+
+	return NULL;
+}
+
+int sclp_read(unsigned long timeout, void *target, int *count)
+{
+	struct read_sccb *sccb;
+	struct evbuf_header *evbuf;
+	struct gds_subvector *sv;
+	struct gds_vector *v;
+	unsigned int cmd;
+	int rc;
+
+	sccb = (void *)get_zeroed_page();
+	evbuf = (struct evbuf_header *)sccb->data;
+retry:
+	memset(sccb, 0, sizeof(struct read_sccb));
+	sccb->header.length = 0x1000;
+
+	cmd = SCLP_CMD_READ_DATA;
+	rc = start_sclp(cmd, sccb);
+	if (rc) {
+		rc = 1;
+		goto out_free_page;
+	}
+
+	if (sccb->header.response_code == 0x20) {
+		v = sclp_find_gds_vector((void *)evbuf + sizeof(*evbuf),
+					 (void *)evbuf + evbuf->length,
+					 GDS_ID_MDSMU);
+		if (!v) {
+			rc = -EIO;
+			goto out_free_page;
+		}
+		sv = sclp_eval_mdsmu(v);
+		if (!sv) {
+			rc = -EIO;
+			goto out_free_page;
+		}
+		*count = sv->length - (sizeof(*sv));
+		memcpy(target, sv + 1, *count);
+		rc = 0;
+		goto out_free_page;
+	}
+
+	if (sccb->header.response_code == 0x60f0) {
+		rc = sclp_wait_for_int(timeout);
+		if (rc) {
+			rc = 2;
+			goto out_free_page;
+		}
+		goto retry;
+	} else {
+		rc = 1;
+	}
+out_free_page:
+	free_page((unsigned long) sccb);
+	return rc;
+}
--- /dev/null
+++ b/zipl/boot/sclp.h
@@ -0,0 +1,156 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Functions for console input and output.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#ifndef SCLP_H
+#define SCLP_H
+
+#include "libc.h"
+#include "s390.h"
+
+/* vector keys and ids */
+#define GDS_ID_MDSMU		0x1310
+#define GDS_ID_CPMSU		0x1212
+#define GDS_ID_TEXTCMD		0x1320
+#define GDS_KEY_SELFDEFTEXTMSG	0x31
+#define EBC_MDB                 0xd4c4c240
+
+#define SCLP_CMD_WRITE_MASK     0x00780005
+#define SCLP_CMD_WRITE_DATA     0x00760005
+#define SCLP_CMD_READ_INFO      0x00120001
+#define SCLP_CMD_READ_INFO2     0x00020001
+#define SCLP_CMD_READ_DATA      0x00770005
+
+#define PSW_EXT_MASK            0x00080000ULL
+#define PSW_EXT_ADDR            0x80000000ULL
+#define PSW_WAIT_MASK           0x010a0000ULL
+#define PSW_WAIT_ADDR           0x00000000ULL
+
+#define CTL_SERVICE_SIGNAL      0x0200
+#define CTL_CLOCK_COMPARATOR    0x0800
+
+#define SCLP_INIT               0x0
+#define SCLP_DISABLE            0x1
+#define SCLP_HSA_INIT           0x2
+#define SCLP_HSA_INIT_ASYNC     0x3
+
+typedef uint32_t sccb_mask_t;
+
+struct gds_vector {
+	uint16_t     length;
+	uint16_t     gds_id;
+} __packed;
+
+struct gds_subvector {
+	uint8_t      length;
+	uint8_t      key;
+} __packed;
+
+struct sccb_header {
+	uint16_t     length;
+	uint8_t      function_code;
+	uint8_t      control_mask[3];
+	uint16_t     response_code;
+} __packed;
+
+struct evbuf_header {
+	uint16_t     length;
+	uint8_t      type;
+	uint8_t      flags;
+	uint16_t     _reserved;
+} __packed;
+
+struct mto {
+	uint16_t length;
+	uint16_t type;
+	uint16_t line_type_flags;
+	uint8_t  alarm_control;
+	uint8_t  _reserved[3];
+} __packed;
+
+struct go {
+	uint16_t length;
+	uint16_t type;
+	uint32_t domid;
+	uint8_t  hhmmss_time[8];
+	uint8_t  th_time[3];
+	uint8_t  reserved_0;
+	uint8_t  dddyyyy_date[7];
+	uint8_t  _reserved_1;
+	uint16_t general_msg_flags;
+	uint8_t  _reserved_2[10];
+	uint8_t  originating_system_name[8];
+	uint8_t  job_guest_name[8];
+} __packed;
+
+struct mdb_header {
+	uint16_t length;
+	uint16_t type;
+	uint32_t tag;
+	uint32_t revision_code;
+} __packed;
+
+struct mdb {
+	struct mdb_header header;
+	struct go go;
+} __packed;
+
+struct msg_buf {
+	struct evbuf_header header;
+	struct mdb mdb;
+} __packed;
+
+struct write_sccb {
+	struct sccb_header header;
+	struct msg_buf msg_buf;
+} __packed;
+
+
+struct init_sccb {
+	struct sccb_header header;
+	uint16_t _reserved;
+	uint16_t mask_length;
+	sccb_mask_t receive_mask;
+	sccb_mask_t send_mask;
+	sccb_mask_t sclp_send_mask;
+	sccb_mask_t sclp_receive_mask;
+} __packed;
+
+struct read_info_sccb {
+	struct  sccb_header header;
+	uint16_t     rnmax;
+	uint8_t      rnsize;
+	uint8_t      _reserved0[24-11];
+	uint8_t      loadparm[8];
+	uint8_t      _reserved1[48-32];
+	uint64_t     facilities;
+	uint8_t      _reserved2[84-56];
+	uint8_t      fac84;
+	uint8_t      fac85;
+	uint8_t      _reserved3[91-86];
+	uint8_t      flags;
+	uint8_t      _reserved4[100-92];
+	uint32_t     rnsize2;
+	uint64_t     rnmax2;
+	uint8_t      _reserved5[4096-112];
+} __packed __aligned(PAGE_SIZE);
+
+struct read_sccb {
+	struct  sccb_header header;
+	uint8_t      data[4096-8];
+} __packed __aligned(PAGE_SIZE);
+
+int start_sclp(unsigned int, void *);
+int sclp_setup(int);
+int sclp_print(char *);
+int sclp_param(char *);
+int sclp_read(unsigned long, void *, int *);
+int sclp_read_info(struct read_info_sccb *sccb);
+int sclp_wait_for_int(unsigned long long);
+
+#endif /* SCLP_H */
--- /dev/null
+++ b/zipl/boot/sclp_stage3.c
@@ -0,0 +1,163 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Functions for console input and output.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "sclp.h"
+#include "sclp_stage3.h"
+
+#define EQ_STORE_DATA	0x0
+#define EQ_SIZE		0x1
+#define DI_FCP_DUMP	0x0
+#define EVTYP_SDIAS	0x1c
+
+/* Global flag for synchrous(1) or asynchronus(0) hsa copy */
+static int hsa_sync_mode = 1;
+
+static int sclp_hsa_copy_wait(struct read_sccb *sccb)
+{
+	unsigned int cmd;
+	int rc;
+
+	memset(sccb, 0, sizeof(struct read_sccb));
+	sccb->header.length = 0x1000;
+
+	cmd = SCLP_CMD_READ_DATA;
+	rc = start_sclp(cmd, sccb);
+
+	if (rc)
+		return rc;
+
+	if (sccb->header.response_code != 0x20)
+		return 1;
+
+	return 0;
+}
+
+static int __sclp_hsa_copy(struct sdias_sccb *sccb, void *dest_addr,
+			   unsigned long first_block, unsigned long nr_blocks)
+{
+	unsigned int cmd;
+	int rc;
+
+	sccb->header.length = sizeof(*sccb);
+
+	sccb->evbuf.header.length = sizeof(sccb->evbuf);
+	sccb->evbuf.header.type = EVTYP_SDIAS;
+	sccb->evbuf.event_qual = EQ_STORE_DATA;
+	sccb->evbuf.event_id = 0x4712;
+	sccb->evbuf.asa_size = 1;
+	sccb->evbuf.asa = (unsigned long) dest_addr;
+	sccb->evbuf.fbn = first_block;
+	sccb->evbuf.blk_cnt = nr_blocks;
+	sccb->evbuf.dbs = 1;
+
+	cmd = SCLP_CMD_WRITE_DATA;
+	rc = start_sclp(cmd, sccb);
+	if (rc)
+		return 1;
+
+	if (sccb->header.response_code != 0x20)
+		return 1;
+
+	if (!hsa_sync_mode) {
+		if (!(S390_lowcore.ext_params & 0x3)) {
+			sclp_wait_for_int(0);
+			if (!(S390_lowcore.ext_params & 0x3))
+				return 1;
+		}
+		if (sclp_hsa_copy_wait((struct read_sccb *)sccb))
+			return 1;
+	}
+	/* Check for expected event status */
+	if ((sccb->evbuf.event_status != SDIAS_EVSTATE_PART_STORED) &&
+	    (sccb->evbuf.event_status != SDIAS_EVSTATE_ALL_STORED))
+		return 1;
+
+	return 0;
+}
+
+int sclp_hsa_copy(void *dest_addr, unsigned long first_block,
+		  unsigned long nr_blocks)
+{
+	struct sdias_sccb *sccb;
+	int rc;
+
+	sccb = (void *)get_zeroed_page();
+	rc = __sclp_hsa_copy(sccb, dest_addr, first_block, nr_blocks);
+	free_page((unsigned long) sccb);
+	return rc;
+}
+
+int sclp_hsa_get_size(unsigned long *hsa_size)
+{
+	struct sdias_sccb *sccb;
+	unsigned int cmd;
+	int rc = -EIO;
+
+	sccb = (void *)get_zeroed_page();
+	sccb->header.length = sizeof(*sccb);
+
+	sccb->header.length = sizeof(*sccb);
+	sccb->evbuf.header.length = sizeof(struct sdias_evbuf);
+	sccb->evbuf.header.type = EVTYP_SDIAS;
+	sccb->evbuf.event_qual = EQ_SIZE;
+	sccb->evbuf.data_id = DI_FCP_DUMP;
+	sccb->evbuf.event_id = 4712;
+	sccb->evbuf.dbs = 1;
+
+	cmd = SCLP_CMD_WRITE_DATA;
+	if (start_sclp(cmd, sccb))
+		goto out;
+	if (sccb->header.response_code != 0x20)
+		goto out;
+
+	if (!hsa_sync_mode) {
+		if (!(S390_lowcore.ext_params & 0x3)) {
+			sclp_wait_for_int(0);
+			if (!(S390_lowcore.ext_params & 0x3))
+				goto out;
+		}
+		if (sclp_hsa_copy_wait((struct read_sccb *)sccb))
+			goto out;
+	}
+	if (sccb->evbuf.blk_cnt) {
+		*hsa_size = (sccb->evbuf.blk_cnt - 1) * PAGE_SIZE;
+		rc = 0;
+	}
+out:
+	free_page((unsigned long) sccb);
+	return rc;
+}
+
+void sclp_hsa_copy_init(void *dest_addr)
+{
+	struct sdias_sccb *sccb;
+
+	sclp_setup(SCLP_HSA_INIT);
+	sccb = (void *)get_zeroed_page();
+	__sclp_hsa_copy(sccb, dest_addr, 2, 1);
+	/* Check buffer that was filled by sclp_hsa_copy */
+	if (sccb->evbuf.event_status != 0) {
+		/* Use synchonous mode */
+		hsa_sync_mode = 1;
+		free_page((unsigned long) sccb);
+		return;
+	}
+
+	/* Use async mode */
+	hsa_sync_mode = 0;
+	free_page((unsigned long) sccb);
+	sclp_setup(SCLP_DISABLE);
+	sclp_setup(SCLP_HSA_INIT_ASYNC);
+}
+
+void sclp_hsa_copy_exit(void)
+{
+	sclp_setup(SCLP_DISABLE);
+	diag308(DIAG308_REL_HSA, NULL);
+}
--- /dev/null
+++ b/zipl/boot/sclp_stage3.h
@@ -0,0 +1,52 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Functions for console input and output.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#ifndef SCLP_STAGE3_H
+#define SCLP_STAGE3_H
+
+#include "sclp.h"
+
+#define SDIAS_EVSTATE_ALL_STORED  0x00
+#define SDIAS_EVSTATE_PART_STORED 0x10
+
+#define SDIAS_EVSTATE_ALL_STORED  0x00
+#define SDIAS_EVSTATE_PART_STORED 0x10
+
+struct sdias_evbuf {
+	struct  evbuf_header header;
+	uint8_t      event_qual;
+	uint8_t      data_id;
+	uint64_t     reserved2;
+	uint32_t     event_id;
+	uint16_t     reserved3;
+	uint8_t      asa_size;
+	uint8_t      event_status;
+	uint32_t     reserved4;
+	uint32_t     blk_cnt;
+	uint64_t     asa;
+	uint32_t     reserved5;
+	uint32_t     fbn;
+	uint32_t     reserved6;
+	uint32_t     lbn;
+	uint16_t     reserved7;
+	uint16_t     dbs;
+} __packed;
+
+struct sdias_sccb {
+	struct sccb_header  header;
+	struct sdias_evbuf  evbuf;
+} __packed;
+
+
+int sclp_hsa_copy(void *, unsigned long, unsigned long);
+int sclp_hsa_get_size(unsigned long *hsa_size);
+void sclp_hsa_copy_init(void *);
+void sclp_hsa_copy_exit();
+
+#endif /* SCLP_H */
--- /dev/null
+++ b/zipl/boot/stage2.c
@@ -0,0 +1,137 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Main program for stage2 bootloader.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "stage2.h"
+#include "error.h"
+#include "libc.h"
+#include "s390.h"
+#include "menu.h"
+
+static int is_null_descriptor(disk_blockptr_t *address)
+{
+	unsigned long long *value = (unsigned long long *)address;
+
+	return *value == 0;
+}
+
+static void *load_blocklist(struct component_entry *descriptor_address,
+			    struct subchannel_id subchannel_id, void *load_address)
+{
+	disk_blockptr_t *indirect_blocks, *indirect_blockspace,
+		*start_addr;
+	unsigned long length;
+	long long nr_descr;
+
+	/* start address to load first indirect blocks */
+	start_addr = (disk_blockptr_t *)&descriptor_address->data;
+	/* get a free page to store indirect blocks in */
+	indirect_blockspace = (void *)get_zeroed_page();
+
+	do {
+		length = extract_length(start_addr);
+		/* calculate number of descriptors to be processed and base 0 */
+		nr_descr = length/DESCR_PER_BLOCK - 1;
+		indirect_blocks = indirect_blockspace;
+		/* load indirect blocks */
+		load_direct(start_addr, subchannel_id, indirect_blocks);
+
+		/* process indirect blocks */
+		while (nr_descr > 0) {
+			if (is_null_descriptor(indirect_blocks))
+				goto out_free_page;
+
+			/* for special zero block simply clear mem */
+			if (!is_zero_block(indirect_blocks)) {
+				length = extract_length(indirect_blocks);
+				memset(load_address, 0, length);
+				load_address += length;
+			} else
+				load_address = load_direct(indirect_blocks,
+							   subchannel_id,
+							   load_address);
+
+			indirect_blocks++;
+			nr_descr--;
+		}
+		/* update pointer for next round */
+		start_addr = indirect_blocks;
+	/* as long as another indirect block needs to be loaded */
+	} while (!is_null_descriptor(indirect_blocks));
+
+out_free_page:
+	free_page((unsigned long)indirect_blockspace);
+	return load_address;
+}
+
+
+static void execute(uint64_t psw)
+{
+	asm volatile(
+		"      lpsw    %[psw]\n"
+		: : [psw] "Q" (psw) : "cc"
+		);
+}
+
+void start(void)
+{
+	struct stage2_descr stage2_descr;
+	struct subchannel_id subchannel_id;
+	void *load_address;
+	struct component_entry *entry;
+	disk_blockptr_t *blockptr;
+	void *load_page;
+	int config_nr;
+
+	subchannel_id = *(struct subchannel_id *)&S390_lowcore.subchannel_id;
+	stage2_descr = *(struct stage2_descr*)STAGE2_DESC;
+
+	/* print menu and get configuration number */
+	config_nr = menu();
+	kdump_stage2(config_nr);
+
+	io_irq_enable();
+	set_device(subchannel_id, ENABLED);
+
+	load_page = (void *)get_zeroed_page();
+	load_address = (disk_blockptr_t *) load_page;
+
+	/* load blockpointer list to load address */
+	load_direct((disk_blockptr_t *)&stage2_descr, subchannel_id,
+		    load_address);
+
+	blockptr = (disk_blockptr_t *)(load_address +
+					     sizeof(disk_blockptr_t));
+
+	load_direct(&blockptr[config_nr], subchannel_id, load_address);
+
+	/* skip header */
+	entry = (struct component_entry *)
+		(load_address + sizeof(struct component_header));
+
+	while (entry->type == COMPONENT_LOAD) {
+		load_address = (void *)(unsigned long)
+			entry->address.load_address[1];
+		load_blocklist(entry, subchannel_id, load_address);
+		entry++;
+	}
+	if (entry->type != COMPONENT_EXECUTE)
+		panic(EWRONGTYPE, "");
+
+	free_page((unsigned long)load_page);
+	io_irq_disable();
+	set_device(subchannel_id, DISABLED);
+
+	execute(entry->address.load_psw);
+}
+
+void panic_notify(unsigned long UNUSED(reason))
+{
+}
+
+uint64_t stage2_head __attribute__((section(".stage2.head")));
--- /dev/null
+++ b/zipl/boot/stage2.h
@@ -0,0 +1,76 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Main program for stage2 bootloader.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#ifndef COMMON_H
+#define COMMON_H
+
+#include "error.h"
+#include "libc.h"
+#include "cio.h"
+#include "s390.h"
+
+#define DESCR_PER_BLOCK         16
+
+/* ADRESS */
+#define STAGE2_DESC 0x78
+
+/* Layout of ECKD disk block pointer */
+struct eckd_blockptr {
+	uint16_t cyl;
+	uint16_t head;
+	uint8_t sec;
+	uint16_t size;
+	uint8_t blockct;
+	uint8_t reserved[8];
+} __packed;
+
+struct linear_blockptr {
+	uint64_t blockno;
+	uint16_t size;
+	uint16_t blockct;
+	uint8_t reserved[4];
+} __packed;
+
+typedef union {
+	struct eckd_blockptr eckd;
+	struct linear_blockptr linear;
+} disk_blockptr_t;
+
+struct component_header {
+	uint8_t magic[4];
+	uint8_t type;
+	uint8_t reserved[27];
+} __packed;
+
+struct component_entry {
+	uint8_t data[23];
+	uint8_t type;
+	union {
+		uint32_t load_address[2];
+		uint64_t load_psw;
+	} address;
+} __packed;
+
+typedef enum {
+	COMPONENT_EXECUTE = 0x01,
+	COMPONENT_LOAD = 0x02
+} component_type;
+
+struct stage2_descr {
+	uint8_t reserved[16];
+} __packed __aligned(8);
+
+void *load_direct(disk_blockptr_t *, struct subchannel_id , void *);
+int extract_length(void *);
+int is_zero_block(void *);
+void kdump_stage2(unsigned long);
+
+
+#endif /* COMMON_H */
+
--- /dev/null
+++ b/zipl/boot/stage2.lds
@@ -0,0 +1,61 @@
+/*
+ * Memory layout for stage 2
+ * =========================
+ *
+ * General memory layout
+ * ---------------------
+ *
+ * 0x0000-0x1fff	Lowcore
+ * 0x2000-0x4fff	Sections (load): head, text, data, rodata, rodata.str
+ * 0x5000-0x51ff	eckd2dump_mv parameter block (426 bytes)
+ * 0x5200-0x5fff	Sections: bss
+ * 0x6000-0x9fff	Memory allocation (heap)
+ * 0xa000-0xdfff        Memory to load stage3 to
+ * 0xe000-0xffff	Stack
+ *
+ * Special memory locations
+ * ------------------------
+ *
+ * 0x78			Stage 2 description parameters
+ * 0x2018		Stage 2 entry point
+ * 0x3ff7		eckd2dump_mv force parameter
+ * 0x3ff8		Max mem dump parameter
+ * 0x5000-0x51ff	eckd2dump_mv parameter block (426 bytes)
+ */
+
+SECTIONS
+{
+  . = 0x78;
+  __stage2_desc = .;
+
+  . = 0x2000;
+  .stage2.head : { *(.stage2.head) }
+  . = 0x2018;
+  .text.start : { *(.text.start) }
+  .text : { *(.text) }
+  __ex_table_start = .;
+  .ex_table : { *(.ex_table) }
+  __ex_table_stop = .;
+  .rodata : {*(.rodata) }
+  .data : { *(.data) }
+  __stage2_params = .;
+
+  . = 0x4ff0;
+  .stage2dump.tail : { *(.stage2dump.tail) }
+  . = 0x5000;
+  .eckd2dump_mv.tail : { *(.eckd2dump_mv.tail) }
+
+  . = 0x5200;
+  __bss_start = .;
+  .bss : { *(.bss) }
+  __bss_stop = .;
+
+  . = 0x6000;
+  __heap_start = .;
+  . = 0xa000;
+  __heap_stop = .;
+
+  . = 0xf000;
+  .eh_frame : { *(.eh_frame) }
+  .note.gnu.build-id : { *(.note.gnu.build-id) }
+}
--- /dev/null
+++ b/zipl/boot/stage2dump.c
@@ -0,0 +1,300 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Common functions for stand-alone dump tools
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#include <stdarg.h>
+#include "stage2dump.h"
+#include "error.h"
+#include "sclp.h"
+
+#define CPU_ADDRESS_MAX	1000
+
+/*
+ * Static globals
+ */
+static unsigned long progress_next_addr;
+static unsigned long progress_inc = 0x20000000; /* Issue message each 512M */
+
+/*
+ * IPL info in lowcore
+ */
+struct ipib_info {
+	unsigned long	ipib;
+	uint32_t	ipib_csum;
+};
+
+/*
+ * Tail parameters
+ */
+struct stage2dump_parm_tail parm_tail
+	__attribute__ ((section(".stage2dump.tail"))) = {
+	.mem_upper_limit = 0xffffffffffffffffULL,
+};
+
+/*
+ * Globals
+ */
+struct df_s390_hdr *dump_hdr;
+
+/*
+ * Init dumper: Allocate standard pages, set timers
+ */
+static void init_early(void)
+{
+	/* Allocate dump header */
+	dump_hdr = (void *) get_zeroed_page();
+
+	/* Set clock comparator and CPU timer to future */
+	set_clock_comparator(0xffffffffffffffffULL);
+	set_cpu_timer(0x7fffffffffffffffULL);
+}
+
+/*
+
+ * Init dump progress messages to sclp console
+ *
+ * 8 messages if the memory is 4G or less, otherwise one message for each
+ * 512M chunk of dumped memory
+ */
+static void progress_init(void)
+{
+	if (dump_hdr->mem_size <= (4 * 1024 * 1024 * 1024ULL))
+		progress_inc = dump_hdr->mem_size >> 3;
+	progress_next_addr = progress_inc;
+}
+
+/*
+ * Print progress message
+ */
+void progress_print(unsigned long addr)
+{
+	if (addr < progress_next_addr && addr != dump_hdr->mem_size)
+		return;
+	printf("%08lu / %08lu MB", addr >> 20, dump_hdr->mem_size >> 20);
+	progress_next_addr += progress_inc;
+}
+
+/*
+ * Create IDA list starting at "addr" with "len" bytes
+ */
+void create_ida_list(unsigned long *list, int len, unsigned long addr,
+		     unsigned long zero_page)
+{
+	unsigned long ida_addr;
+
+	while (len > 0) {
+		if (zero_page)
+			ida_addr = page_is_valid(addr) ? addr : zero_page;
+		else
+			ida_addr = addr;
+		*list = ida_addr;
+		list++;
+		addr += PAGE_SIZE;
+		len -= PAGE_SIZE;
+	}
+}
+
+/*
+ * Initialize s390 dump header
+ */
+static void df_s390_dump_init(void)
+{
+	struct df_s390_hdr *dh = dump_hdr;
+
+	dh->magic = DF_S390_MAGIC;
+	dh->hdr_size = DF_S390_HDR_SIZE;
+	dh->page_size = PAGE_SIZE;
+	dh->dump_level = 4;
+	dh->version = 5;
+	dh->mem_start = 0;
+	dh->arch = DF_S390_ARCH_64;
+	dh->build_arch = DF_S390_ARCH_64;
+	get_cpu_id((struct cpuid *) &dh->cpu_id);
+	dh->tod = get_tod_clock();
+	dh->volnr = 0;
+}
+
+/*
+ * Initialize page with end marker
+ */
+void df_s390_em_page_init(unsigned long addr)
+{
+	struct df_s390_em *em = (void *) addr;
+
+	em->magic = DF_S390_EM_MAGIC;
+	em->tod = get_tod_clock();
+}
+
+/*
+ * Find out memory size
+ */
+static void count_mem(void)
+{
+	unsigned long mem_size_max, mem_size, addr, rnmax, rzm;
+	struct read_info_sccb *sccb;
+
+	sccb = (void *) get_zeroed_page();
+	/* Get memory max */
+	if (sclp_read_info(sccb))
+		panic(EMEMCOUNT, "Could not evaluate memory layout");
+	rnmax = sccb->rnmax ? sccb->rnmax : sccb->rnmax2;
+	rzm = sccb->rnsize ? sccb->rnsize : sccb->rnsize2;
+	rzm <<= 20;
+	mem_size_max = rnmax * rzm;
+	mem_size = 0;
+	/* Find out real memory end without standby memory */
+	for (addr = 0; addr < mem_size_max; addr += rzm) {
+		if (!page_is_valid(addr))
+			continue;
+		mem_size = addr + rzm;
+	}
+	free_page((unsigned long) sccb);
+
+	dump_hdr->mem_size_real = mem_size;
+	/* Check if we have an upper limit */
+	if (mem_size > parm_tail.mem_upper_limit) {
+		printf("Using memory limit");
+		mem_size = parm_tail.mem_upper_limit;
+	}
+	dump_hdr->mem_size = dump_hdr->mem_end = mem_size;
+	dump_hdr->num_pages = dump_hdr->mem_size >> 12;
+}
+
+/*
+ * Copy 64 bit lowcore after store status
+ */
+static void copy_lowcore_64(void)
+{
+	char *real_cpu_cnt_ptr = ((char *) &dump_hdr->mem_size_real) + 11;
+	char *cpu_cnt_ptr = ((char *) &dump_hdr->mem_size_real) + 9;
+	unsigned long prefix;
+	uint16_t cpu_cnt = 0;
+
+	prefix = S390_lowcore.prefixreg_save_area;
+
+	/* Need memcpy because of aligment problem of members */
+	memcpy(&cpu_cnt, real_cpu_cnt_ptr, sizeof(cpu_cnt));
+	cpu_cnt++;
+	memcpy(real_cpu_cnt_ptr, &cpu_cnt, sizeof(cpu_cnt));
+
+	if (prefix < 0x10000) /* if < linux-start addr */
+		return;
+	if (prefix % 0x1000) /* check page alignment */
+		return;
+
+	/* Save lowcore pointer (32 bit) in dump header */
+	memcpy(&cpu_cnt, cpu_cnt_ptr, sizeof(cpu_cnt));
+	dump_hdr->lc_vec[cpu_cnt] = prefix;
+	cpu_cnt++;
+	memcpy(cpu_cnt_ptr, &cpu_cnt, sizeof(cpu_cnt));
+	/*
+	 *  |-----------------------------------------------------------|
+	 *  | Decimal |  Length   | Data                                |
+	 *  | Address |  in Bytes |                                     |
+	 *  |_________|___________|_____________________________________|
+	 *  | 163     | 1         | Architectural Mode ID               |
+	 *  | 4608    | 128       | Fl-pt registers 0-15                |
+	 *  | 4736    | 128       | General registers 0-15              |
+	 *  | 4864    | 16        | Current PSW                         |
+	 *  | 4888    | 4         | Prefix register                     |
+	 *  | 4892    | 4         | Fl-pt control register              |
+	 *  | 4900    | 4         | TOD programmable register           |
+	 *  | 4904    | 8         | CPU timer                           |
+	 *  | 4912    | 1         | Zeros                               |
+	 *  | 4913    | 7         | Bits 0-55 of clock comparator       |
+	 *  | 4928    | 64        | Access registers 0-15               |
+	 *  | 4992    | 128       | Control registers 0-15              |
+	 *  |_________|___________|_____________________________________|
+	 */
+	memcpy((void *) prefix + 4608, (void *) 4608, 272);
+	memcpy((void *) prefix + 4888, (void *) 4888, 8);
+	memcpy((void *) prefix + 4900, (void *) 4900, 20);
+	memcpy((void *) prefix + 4928, (void *) 4928, 192);
+}
+
+/*
+ * Do store status
+ */
+static void store_status(void)
+{
+	unsigned short current_cpu;
+	unsigned long page;
+	int addr, cc;
+
+	/* Save absolute zero lowcore */
+	page = get_zeroed_page();
+	memcpy((void *) page, (void *) 0x1000, PAGE_SIZE);
+
+	current_cpu = stap();
+
+	copy_lowcore_64();
+
+	for (addr = 0; addr < CPU_ADDRESS_MAX; addr++) {
+		if (addr == current_cpu)
+			continue;
+		do {
+			cc = sigp(addr, SIGP_STOP_AND_STORE_STATUS, 0, NULL);
+		} while (cc == SIGP_CC_BUSY);
+
+		if (cc != SIGP_CC_ORDER_CODE_ACCEPTED)
+			continue;
+		copy_lowcore_64();
+	}
+	/* Restore absolute zero lowcore */
+	memcpy((void *) 0x1000, (void *) page, PAGE_SIZE);
+	free_page(page);
+}
+
+/*
+ * Perform reipl: check lowcore for the address of an IPL Information
+ * Block followed by a valid checksum (as defined in lowcore.h and set
+ * by ipl.c). In case of match use diag308 to IPL.
+ */
+static void dump_exit(unsigned long code)
+{
+	struct ipib_info *ipib_info = (struct ipib_info *)&S390_lowcore.ipib;
+	uint32_t ipib_len, csum;
+
+	if (!ipib_info->ipib)
+		libc_stop(code);
+	ipib_len = *((uint32_t *) ipib_info->ipib);
+	csum = csum_partial((void *) ipib_info->ipib, ipib_len, 0);
+	if (ipib_info->ipib_csum != csum)
+		libc_stop(code);
+	diag308(DIAG308_SET, (void *) ipib_info->ipib);
+	diag308(DIAG308_IPL, NULL);
+}
+
+/*
+ * Print message and exit dumper
+ */
+void panic_notify(unsigned long code)
+{
+	printf("Dump failed");
+	dump_exit(code);
+}
+
+/*
+ * Create stand-alone dump
+ */
+void start(void)
+{
+	init_early();
+	store_status();
+	dt_device_parm_setup();
+	sclp_setup(SCLP_INIT);
+	dt_device_enable();
+	df_s390_dump_init();
+	printf("zIPL v%s dump tool (64 bit)", RELEASE_STRING);
+	printf("Dumping 64 bit OS");
+	count_mem();
+	progress_init();
+	dt_dump_mem();
+	printf("Dump successful");
+	dump_exit(0);
+}
